/*
 * REPOWEB, repository manager.
 *
 * Terms of license - http://opensource.org/licenses/apachepl.php
 */
package idea.jalopy;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.*;


/**
 * Plugin config panel. Display the defaut jalopy panel.
 *
 * @version $Revision: 1.3 $
 */
final class PluginConfigPanel
    extends JPanel
{
    private JButton   prefButton     = new JButton( "Jalopy Config Panel" );
    private JCheckBox optimizeImport = new JCheckBox( "Optimize import" );

    PluginConfigPanel (  )
    {
        prefButton.addActionListener ( new ActionListener(  )
            {
                public void actionPerformed ( ActionEvent e )
                {
                    JalopyPlugin.displayJalopyPref ( PluginConfigPanel.this );
                }
            } );

        JPanel config = new JPanel( new GridBagLayout(  ) );
        config.setBorder ( BorderFactory.createTitledBorder ( "Configuration" ) );

        GridBagConstraints constraint = new GridBagConstraints(  );
        constraint.insets = new Insets( 5, 5, 5, 5 );
        constraint.anchor = GridBagConstraints.WEST;
        config.add ( prefButton, constraint );

        constraint         = ( GridBagConstraints ) constraint.clone (  );
        constraint.gridy   = 2;
        constraint.weightx = 1.0;
        config.add ( buildSpecificPanel (  ), constraint );

        setLayout ( new BorderLayout( 10, 10 ) );
        add ( buildAbout (  ), BorderLayout.NORTH );
        add ( config, BorderLayout.CENTER );
        setBorder ( BorderFactory.createEmptyBorder ( 10, 10, 10, 10 ) );
    }

    private JEditorPane buildAbout (  )
    {
        final JEditorPane about = new JEditorPane(  );
        about.setContentType ( "text/html" );
        about.setEditable ( false );
        about.setText ( "<html><body><h1>Jalopy for Idea 4</h1>" + "Integrates jalopy into IntelliJ IDEA.<p>" + "<u>Jalopy's License :</u> <br><code>"
                        + "This software is distributable under the BSD license. <br>See the terms of the BSD license in the documentation <br>provided with this software." + "</code><p>"
                        + "<u>Plugin's License :</u> <br><code> http://opensource.org/licenses/apachepl.php." + "</code><p>" + "Jalopy WebSite : <a href=\"http://jalopy.sf.net/\">http://jalopy.sf.net</a><br>"
                        + "Plugin WebSite : <a href=\"http://repoweb.sf.net\">http://repoweb.sf.net</a><br>" );
        about.setOpaque ( false );

        return about;
    }

    private JPanel buildSpecificPanel (  )
    {
        JPanel specific = new JPanel( new BorderLayout(  ) );
        JLabel info     = new JLabel( "Use IDEA 'optimize import' function" );
        info.setFont ( info.getFont (  ).deriveFont ( Font.ITALIC ) );
        specific.add ( info, BorderLayout.SOUTH );
        specific.add ( optimizeImport, BorderLayout.CENTER );

        return specific;
    }

    public void setOptimizeImport ( boolean optimizeImport )
    {
        this.optimizeImport.setSelected ( optimizeImport );
    }

    public boolean isOptimizeImport (  )
    {
        return this.optimizeImport.isSelected (  );
    }
}
